//  Target Organization:  RTTC Dynamic Test Branch (TA-2)
//  Develpment Organization : Trideum Corporation
//  Developer : Mike Greene   mgreene@trideum.com
//  Developer's Phone :  (256) 704-6113
//  OpenSceneGraph Version 1.1  (www.openscenegraph.org)
//
//  Last Mod 03-21-2007
//
// LoadXMLDlg.cpp : implementation file
//

#include "stdafx.h"
#include "terrain_mapper.h"
#include "LoadXMLDlg.h"

#include <string>
#include <vector>
#include ".\loadxmldlg.h"

#include "DlgGetPath.h"                //Definition to getpath code (from codeproject.com)

int savedIndexXML =  0;                // current selected file index in combobox

bool bDuringInitializationXML = true;  // if during init phase, manually set default search path
bool bUseInputXMLFile = false;         // reset after 1st XML file read
bool bGoodFileSelection = false;       // flag to signify a good XML file selected


std::string globalInputXMLFile;        // file name of XML input file
std::string sSearchPath;

// CLoadXMLDlg dialog

IMPLEMENT_DYNAMIC(CLoadXMLDlg, CDialog)
CLoadXMLDlg::CLoadXMLDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoadXMLDlg::IDD, pParent)
{
}

CLoadXMLDlg::~CLoadXMLDlg()
{
}

void CLoadXMLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_LOADXML, cComboLoadXML);
}


BEGIN_MESSAGE_MAP(CLoadXMLDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_LOADXML, OnCbnSelchangeComboLoadxml)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_CHGDIR_XML, OnBnClickedButtonChgdirXml)
END_MESSAGE_MAP()


// CLoadXMLDlg message handlers

BOOL CLoadXMLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	bDuringInitializationXML = true;
	UpdateFileListBox();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// routine to update list of files in ComboBox
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void CLoadXMLDlg::UpdateFileListBox(void)
{
		savedIndexXML =  0;
		
		WIN32_FIND_DATA FindFileData; 
		HANDLE hFind = INVALID_HANDLE_VALUE; 
		char DirSpec[MAX_PATH]; // directory specification 
		//std::string savedDir;

		cComboLoadXML.ResetContent(); //reset list box to  blanks

		if (bDuringInitializationXML) {
			// first time set default search path
			m_sPath = "C:\\TA2_07\\terrain_mapper\\";
			strcpy(DirSpec, m_sPath);
			SetDlgItemText(IDC_STATIC_PATH, m_sPath);
			bDuringInitializationXML = false;
		}
		else {
			//user selected an alternate search path
			strcpy(DirSpec, m_sPath);
		}
		
		// show only XML files
		strncat(DirSpec, "\\*.xml", 6);
		
		std::vector< std::string > fileListVector ;

		// load XML files into combo box
		hFind = FindFirstFile(DirSpec, &FindFileData);
		cComboLoadXML.InsertString(savedIndexXML,FindFileData.cFileName);
		fileListVector.push_back( FindFileData.cFileName );
		savedIndexXML++;

		
        // sort thru files found and put in list box
		while(FindNextFile(hFind, &FindFileData) != 0)
		{
			cComboLoadXML.InsertString(savedIndexXML,FindFileData.cFileName);
			fileListVector.push_back( FindFileData.cFileName );
			
			savedIndexXML++;
		}
		FindClose(hFind);

}

// routine to process combobox selection
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void CLoadXMLDlg::OnCbnSelchangeComboLoadxml()
{
	int nIndex = cComboLoadXML.GetCurSel();
    
    cComboLoadXML.GetLBText(nIndex, sInputXMLFile);
	// prepend path to xml file name and signal that a file has been chosen
	globalInputXMLFile = std::string( (LPCTSTR) m_sPath) + std::string ((LPCTSTR) sInputXMLFile);
	bGoodFileSelection = true;
}

// routine close XML selection dialog
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void CLoadXMLDlg::OnBnClickedOk()
{
	// if godd XML selected, set good file flag to true, and Use XML input dialog flag to false
	//   so that it may be reused if another XML input is desired
	if (bGoodFileSelection) {
		bUseInputXMLFile = true;
		bGoodFileSelection = false;
	}
	OnOK();
}

// routine to launch directory selection box (from codeproject.com)
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void CLoadXMLDlg::OnBnClickedButtonChgdirXml()
{
	CDlgGetPath dlg( this );
		dlg.SetPath( m_sPath );
		if( dlg.DoModal() == IDOK )
		{
			m_sPath = dlg.GetPath( );
			SetDlgItemText(IDC_STATIC_PATH, m_sPath);
			
			UpdateFileListBox();

			UpdateData( false );
		}
}
