//  Target Organization:  RTTC Dynamic Test Branch (TA-2)
//  Develpment Organization : Trideum Corporation
//  Developer : Mike Greene   mgreene@trideum.com
//  Developer's Phone :  (256) 704-6113
//  OpenSceneGraph Version 1.1  (www.openscenegraph.org)
//
//  Last Mod 03-21-2007
//
//   terrain_mapperDlg.cpp

#include "stdafx.h"
#include "terrain_mapper.h"
#include "terrain_mapperDlg.h"
#include ".\terrain_mapperdlg.h"

#include "LoadXMLDlg.h"

#include <ace/os.h>
#include "ace/ace.h"

#define TENA_PLATFORM xp-vc71-d
#define MAXSEARCHPATHS  10   // maximum number of paths added to search list for terrain textures
#define PANSCALE  10         // value to scale pan slider movements (so you won't have so many tic marks)
#include "aceosgthread.h"
#include "DlgGetPath.h"      //Definition to getpath gathering code (from codeproject.com)

#include <string>
#include <vector>
#include <time.h>

extern void ExitApp(void);

using namespace std;

//#ifdef _DEBUG
//#define new DEBUG_NEW
//#endif

//global dlg vars to pass to OSG thread for control
bool globalStartPolygon = false;
bool globalEndPolygon = false;
bool globalAddNewPath = false;
bool bStartNewPolygon = false;
std::string globalOSGTerrainName;
std::string globalSavedDir[MAXSEARCHPATHS];
std::string globalXMLFilename;
int globalNumberSearchPaths = 0;
int globalOSGPanValue = 0;
int globalOSGPanUpValue = 0;
float globalOSGZoomValue = 1.0;

bool bDuringInitialization = true;  //initialization flag for populating combo boxes
bool bReleaseXMLMenu = false;       // if terrain is loaded, enable XML input menu
int savedIndex =  0;                // index for currently selected combobox entry

extern std::ofstream stream;     //xml output stream
extern int selectedTerrainType;  // currently selected terrain type from enum below :

enum terrainType  {TWOINCHWASHBOARD=0 , SIXINCHWASHBOARD=1, RADIALWASHBOARD=2, 
                   BELGIANBLOCK=3, EMBEDDEDROCK=4, CROSSCOUNTRY=5, GRAVELROAD=6,
                   PAVEDROAD=7, NOTTRAVERSABLE=8};

extern std::string sXMLLTPlat;
extern std::string sXMLLTPlon;
extern std::string sXMLLTPaz;

extern std::string sXMLLTP_XfalseOrigin;
extern std::string sXMLLTP_YfalseOrigin;
extern std::string sXMLLTP_heightOffset;


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cterrain_mapperDlg dialog



Cterrain_mapperDlg::Cterrain_mapperDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cterrain_mapperDlg::IDD, pParent)
	, m_RadioType(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
    c_MenuVar.LoadMenu(IDR_MENU1);
}

void Cterrain_mapperDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_TERRAIN, cComboTerrain);
	DDX_Radio(pDX, IDC_RADIO_2INCHWASHBOARD, m_RadioType);
	DDX_Control(pDX, IDC_STATIC_DIRCHANGE, cTerrainGroupBox);
	DDX_Control(pDX, IDC_EDIT_XMILFILENAME, cEditXMLFilename);
	DDX_Control(pDX, IDC_SLIDER2, c_Slider_UpDown);
	DDX_Control(pDX, IDC_SLIDER1, c_Slider_LeftRight);
	DDX_Control(pDX, IDC_BUTTON_HOME, c_HomeButton);
	DDX_Control(pDX, IDC_BUTTON_ZOOMOUT, c_Button_ZoomOut);
	DDX_Control(pDX, IDC_BUTTON_ZOOMIN, c_Button_ZoomIn);
	DDX_Control(pDX, IDC_EDIT_LTPLAT, cLTPLat);
	DDX_Control(pDX, IDC_EDIT_LTPLON, cLTPLon);
	DDX_Control(pDX, IDC_EDIT_LTPAZ, cLTPAz);
	DDX_Control(pDX, IDC_EDIT_XFALSEORIGIN, cXFalseOrigin);
	DDX_Control(pDX, IDC_EDIT_YFALSEORIGIN, cYFalseOrigin);
	DDX_Control(pDX, IDC_EDIT_HEIGHTOFFSET, cHeightOffset);
}

BEGIN_MESSAGE_MAP(Cterrain_mapperDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_STARTOSG, OnBnClickedButtonStartosg)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_STARTPOLY, OnBnClickedButtonStartpoly)
	ON_BN_CLICKED(IDC_BUTTON_ENDPOLY, OnBnClickedButtonEndpoly)
	ON_BN_CLICKED(IDC_BUTTON_DIR, OnBnClickedButtonDir)
	ON_CBN_SELCHANGE(IDC_COMBO_TERRAIN, OnCbnSelchangeComboTerrain)
	ON_BN_CLICKED(IDC_RADIO_2INCHWASHBOARD, OnBnClickedRadio2inchwashboard)
	ON_BN_CLICKED(IDC_RADIO_6INCHWASHBOARD, OnBnClickedRadio6inchwashboard)
	ON_BN_CLICKED(IDC_RADIO_RADIALWASHBOARD, OnBnClickedRadioRadialwashboard)
	ON_BN_CLICKED(IDC_RADIO_BELGIANBLOCK, OnBnClickedRadioBelgianblock)
	ON_BN_CLICKED(IDC_RADIO_EMBEDDEDROCK, OnBnClickedRadioEmbeddedrock)
	ON_BN_CLICKED(IDC_RADIO_CROSSCOUNTRY, OnBnClickedRadioCrosscountry)
	ON_BN_CLICKED(IDC_RADIO_GRAVELROAD, OnBnClickedRadioGravelroad)
	ON_BN_CLICKED(IDC_RADIO_PAVEDROAD, OnBnClickedRadioPavedroad)
	ON_BN_CLICKED(IDC_BUTTON_ADDDIR, OnBnClickedButtonAdddir)
	ON_BN_CLICKED(IDC_RADIO_NOTTRAVERSABLE, OnBnClickedRadioNottraversable)
	ON_BN_CLICKED(IDC_BUTTON_CHANGEXML, OnBnClickedButtonChangexml)
	ON_BN_CLICKED(IDC_BUTTON_HOME, OnBnClickedButtonHome)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMOUT, OnBnClickedButtonZoomout)
	ON_BN_CLICKED(IDC_BUTTON_ZOOMIN, OnBnClickedButtonZoomin)

	ON_COMMAND(ID_FILE_OPENEXISTINGMAPFILE, OnMenuOpenMapFile)
	ON_BN_CLICKED(IDC_BUTTON_UPDATELTP, OnBnClickedButtonUpdateltp)
END_MESSAGE_MAP()


// Cterrain_mapperDlg message handlers

BOOL Cterrain_mapperDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// populate terrain combobox
	UpdateFileListBox();
	// disable buttons until appropriate actions ahve been performed
	GetDlgItem(IDC_BUTTON_ENDPOLY)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STARTOSG)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STARTPOLY)->EnableWindow(FALSE);
	
	// Calculate XML output filename based on current time
	// Get GMT Time
	long seconds = time(0);
	struct tm *gt = gmtime(&seconds);
	DWORD StartTime = GetTickCount();
	char tempXMLFileName[260];

	//  create XML filename to write Terrain Map to
	//   Include current time as part of file name for uniqueness
	sprintf(tempXMLFileName,"points_%02d%02d%02d-%02d%02d%02d.xml",gt->tm_mon+1,gt->tm_mday,gt->tm_year-100,
		             gt->tm_hour,gt->tm_min,gt->tm_sec);

    globalXMLFilename = (LPCTSTR)tempXMLFileName;

	// populate editbox with current output file name
	cEditXMLFilename.SetWindowText(globalXMLFilename.c_str());

	// set up default pan and zoom slider parameter values
	c_Slider_LeftRight.SetRange(-60,60);
	c_Slider_LeftRight.SetPos(0);
	c_Slider_LeftRight.SetTicFreq(5);
	c_Slider_LeftRight.SetScrollPos(0,0);
	c_Slider_LeftRight.SetThumbColor(RGB(255, 0, 0));
	c_Slider_LeftRight.SetSelectionColor(RGB(255, 64, 64));
	c_Slider_LeftRight.SetChannelColor(RGB(255, 196, 196));

	c_Slider_UpDown.SetRange(-60,60);
	c_Slider_UpDown.SetPos(0);
	c_Slider_UpDown.SetTic(12);
	c_Slider_UpDown.SetTicFreq(5);
	c_Slider_UpDown.SetScrollPos(0,0);
	
	c_Slider_UpDown.SetThumbColor(RGB(255, 0, 0));
	c_Slider_UpDown.SetSelectionColor(RGB(255, 64, 64));
	c_Slider_UpDown.SetChannelColor(RGB(255, 196, 196));

	// Add the Glyph buttons
	c_HomeButton.SetGlyphEx(-30, FW_BOLD, "Classified", 72);

	c_Button_ZoomIn.SetGlyphEx(-30, FW_BOLD, "MarVoSym", 188);
	c_Button_ZoomOut.SetGlyphEx(-30, FW_BOLD, "MarVoSym", 189);

    SetMenu(&c_MenuVar);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void Cterrain_mapperDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cterrain_mapperDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cterrain_mapperDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// routine to launch OSG God's eye view for terrain mapping
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonStartosg()
{
	// Use ACE routines to launch new thread
	thread_data myArgs;
    ACE::init();
	ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
	
	tm->spawn(ACE_THR_FUNC(StartOSGThread), (void *) &myArgs);
	
	ACE_OS::sleep(ACE_Time_Value(5,0));

	// Now that terrain has been displayed, enable/disable dialog buttons as necessary
	bReleaseXMLMenu = true;
	GetDlgItem(IDC_BUTTON_STARTOSG)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DIR)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STARTPOLY)->EnableWindow(TRUE);
}

void Cterrain_mapperDlg::OnBnClickedOk()
{
	ExitApp();
	OnOK();
}
// routine to Begin accumulation of a polygon's vertices for making a terrain area
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonStartpoly()
{
	bStartNewPolygon = true;
	globalStartPolygon = true;
	GetDlgItem(IDC_BUTTON_STARTPOLY)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_ENDPOLY)->EnableWindow(TRUE);
	//Disable all Terrain Type radio buttons so they don't change mid-polygon
	GetDlgItem(IDC_RADIO_2INCHWASHBOARD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_6INCHWASHBOARD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_RADIALWASHBOARD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_BELGIANBLOCK)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_EMBEDDEDROCK)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_CROSSCOUNTRY)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_GRAVELROAD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_PAVEDROAD)->EnableWindow(FALSE);
	GetDlgItem(IDC_RADIO_NOTTRAVERSABLE)->EnableWindow(FALSE);
	//Disable terrain and texture path buttons (one terrain per session)
	GetDlgItem(IDC_BUTTON_DIR)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_ADDDIR)->EnableWindow(FALSE);
	//Once writing has begun, can't change xml file name
	GetDlgItem(IDC_BUTTON_CHANGEXML)->EnableWindow(FALSE);

}
// routine to End accumulation of a polygon's vertices for making a terrain area
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonEndpoly()
{
	bStartNewPolygon = false;
	globalEndPolygon = true;
	GetDlgItem(IDC_BUTTON_STARTPOLY)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_ENDPOLY)->EnableWindow(FALSE);
	// Re-Enable Terrain selection radio buttons
	GetDlgItem(IDC_RADIO_2INCHWASHBOARD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_6INCHWASHBOARD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_RADIALWASHBOARD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_BELGIANBLOCK)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_EMBEDDEDROCK)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_CROSSCOUNTRY)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_GRAVELROAD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_PAVEDROAD)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_NOTTRAVERSABLE)->EnableWindow(TRUE);
}

void Cterrain_mapperDlg::OnLbnSelchangeListTerrain()
{
	// TODO: Add your control notification handler code here
}

// routine to populate combobox with file names from a given directory
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::UpdateFileListBox(void)
{
		savedIndex =  0;
		
		WIN32_FIND_DATA FindFileData; 
		HANDLE hFind = INVALID_HANDLE_VALUE; 
		char DirSpec[MAX_PATH]; // directory specification 
		
		cComboTerrain.ResetContent(); //reset list box to  blanks

		if (bDuringInitialization) {
			// first time combo box appears do this
			globalSavedDir[globalNumberSearchPaths] = "C:\\OSG1\\NPS_Tutorials\\NPSData\\Models\\JoeDirt\\";
			strcpy(DirSpec, globalSavedDir[globalNumberSearchPaths].c_str());
			SetDlgItemText(IDC_STATIC_DIR, globalSavedDir[globalNumberSearchPaths].c_str());
			bDuringInitialization = false;
		}
		else {
			// user has selected an alternate path
			strcpy(DirSpec, m_sPath);
			globalSavedDir[globalNumberSearchPaths] = std::string((LPCTSTR) m_sPath);
		}
        // look for all file types
		strncat(DirSpec, "\\*.*", 6);
		
		std::vector< std::string > fileListVector ;

		// insert file names from saved vector into combobox
		hFind = FindFirstFile(DirSpec, &FindFileData);
		cComboTerrain.InsertString(savedIndex,FindFileData.cFileName);
		fileListVector.push_back( FindFileData.cFileName );
		savedIndex++;
		
        // sort thru files found and put in list box
		while(FindNextFile(hFind, &FindFileData) != 0)
		{
			cComboTerrain.InsertString(savedIndex,FindFileData.cFileName);
			fileListVector.push_back( FindFileData.cFileName );
			
			savedIndex++;
		}
		FindClose(hFind);

		globalNumberSearchPaths++;

}
// routine allow user to select an alternate search path (from codeproject.com)
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonDir()
{
		CDlgGetPath dlg( this );
		dlg.SetPath( m_sPath );
		if( dlg.DoModal() == IDOK )
		{
			m_sPath = dlg.GetPath( );
			SetDlgItemText(IDC_STATIC_DIR, m_sPath);
			
			UpdateFileListBox();

			UpdateData( false );
		}
}

// routine to process user's selection of name in combobox
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnCbnSelchangeComboTerrain()
{
	int nIndex = cComboTerrain.GetCurSel();
    
    cComboTerrain.GetLBText(nIndex, sTerrainFile);
	//MessageBox(sTerrainFile,"",MB_OK);
	globalOSGTerrainName = std::string( (LPCTSTR) sTerrainFile);
	if (globalOSGTerrainName.length() > 4) {
		// if terrain file has been selected, this box then becomes a path search box
		cTerrainGroupBox.SetWindowText("Add Directory to Texture Path Search list");
		GetDlgItem(IDC_BUTTON_STARTOSG)->EnableWindow(TRUE);
	}
	else
		MessageBox("You must select a Terrain file to map!","ERROR!",MB_OK); //bad selection

}

// routine(s) to set selected global terrain type based on radio button selection
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedRadio2inchwashboard()
{
	//MessageBox("Radio 0","",MB_OK);
	selectedTerrainType = TWOINCHWASHBOARD;
}

void Cterrain_mapperDlg::OnBnClickedRadio6inchwashboard()
{
	//MessageBox("Radio 1","",MB_OK);
	selectedTerrainType = SIXINCHWASHBOARD;
}

void Cterrain_mapperDlg::OnBnClickedRadioRadialwashboard()
{
	//MessageBox("Radio 2","",MB_OK);
	selectedTerrainType = RADIALWASHBOARD;
}

void Cterrain_mapperDlg::OnBnClickedRadioBelgianblock()
{
	//MessageBox("Radio 3","",MB_OK);
	selectedTerrainType = BELGIANBLOCK;
}

void Cterrain_mapperDlg::OnBnClickedRadioEmbeddedrock()
{
	//MessageBox("Radio 4","",MB_OK);
	selectedTerrainType = EMBEDDEDROCK;
}

void Cterrain_mapperDlg::OnBnClickedRadioCrosscountry()
{
	//MessageBox("Radio 5","",MB_OK);
	selectedTerrainType = CROSSCOUNTRY;
}

void Cterrain_mapperDlg::OnBnClickedRadioGravelroad()
{
	//MessageBox("Radio 6","",MB_OK);
	selectedTerrainType = GRAVELROAD;
}

void Cterrain_mapperDlg::OnBnClickedRadioPavedroad()
{
	//MessageBox("Radio 7","",MB_OK);
	selectedTerrainType = PAVEDROAD;
}

void Cterrain_mapperDlg::OnBnClickedRadioNottraversable()
{
	selectedTerrainType = NOTTRAVERSABLE;
}

// routine to signal that user wants to add terrain texture search path
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonAdddir()
{
	globalAddNewPath = true;
}

// routine to signal that user wants to change default XML output file name
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonChangexml()
{
	CString sXMLName;

	cEditXMLFilename.GetWindowText(sXMLName);
	MessageBox(sXMLName,"",MB_OK);
	globalXMLFilename = std::string((LPCTSTR) sXMLName);
}

// routine to process PAN scrolling
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	//MessageBox("Scrolling!","Message",MB_OK);
	if (pScrollBar == NULL)
		return;
    CString str = _T("");
	if (pScrollBar->m_hWnd == c_Slider_LeftRight.m_hWnd)
	{

		int m_nRed = c_Slider_LeftRight.GetPos();
		
		str.Format("%3d", m_nRed);
		globalOSGPanValue = m_nRed*PANSCALE;
		GetDlgItem(IDC_STATIC_PANTEXT)->SetWindowText(str);

		UpdateData(FALSE);
		CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
		
	}
}

// routine to process Up/Down scrolling
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	//MessageBox("Scrolling!","Message",MB_OK);
	if (pScrollBar == NULL)
		return;
    CString str = _T("");
	if (pScrollBar->m_hWnd == c_Slider_UpDown.m_hWnd)
	{

		int m_nRed = c_Slider_UpDown.GetPos();
		
		str.Format("%3d", m_nRed);
		globalOSGPanUpValue = m_nRed*PANSCALE;
		GetDlgItem(IDC_STATIC_PANUPTEXT)->SetWindowText(str);

		UpdateData(FALSE);
		CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
		
	}
}

// routine to process set Zoom factor to default
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonHome()
{
	globalOSGZoomValue = 1.0;
}

// routine to decrease Zoom factor
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonZoomout()
{
	globalOSGZoomValue *= 0.9;
}

// routine to increase Zoom factor
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnBnClickedButtonZoomin()
{
	globalOSGZoomValue *= 1.1;
}

// routine(s) to control popup menus
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 03/21/2007
void Cterrain_mapperDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	UpdateMenu(pPopupMenu);
}

void Cterrain_mapperDlg::UpdateMenu (CMenu* pMenu)
{
	CCmdUI cmdUI;
	
	if (NULL != pMenu)
	{
		for (UINT n = 0; n < pMenu->GetMenuItemCount(); ++n)
		{
			CMenu* pSubMenu = pMenu->GetSubMenu(n);
			
			if (NULL != pSubMenu)
			{
				UpdateMenu (pSubMenu);		// recursive call
			}
			else
			{
				cmdUI.m_nIndex = n;
				cmdUI.m_nID = pMenu->GetMenuItemID(n);
				cmdUI.m_pMenu = pMenu;
				// Need to set this value otherwise you will assert when
				// you have an empty recent file list.
				cmdUI.m_nIndexMax = pMenu->GetMenuItemCount();
				cmdUI.DoUpdate(this, FALSE);
			}
		}	
	}
}

void Cterrain_mapperDlg::OnMenuOpenMapFile()
{
	if (bReleaseXMLMenu) {
		CLoadXMLDlg Dlg;

		Dlg.DoModal();

		Sleep(2000);
        
        cLTPLat.SetWindowText(sXMLLTPlat.c_str());
		cLTPLon.SetWindowText(sXMLLTPlon.c_str());
		cLTPAz.SetWindowText(sXMLLTPaz.c_str());

		cXFalseOrigin.SetWindowText(sXMLLTP_XfalseOrigin.c_str());
		cYFalseOrigin.SetWindowText(sXMLLTP_YfalseOrigin.c_str());
		cHeightOffset.SetWindowText(sXMLLTP_heightOffset.c_str());

		UpdateData(FALSE);

	}
	else {
		MessageBox("Must load terrain first!","Error!",MB_OK);
	}
}
void Cterrain_mapperDlg::OnBnClickedButtonUpdateltp()
{
	CString sGetInputText;

	cLTPLat.GetWindowText(sGetInputText);
	sXMLLTPlat = std::string((LPCTSTR) sGetInputText);

	cLTPLon.GetWindowText(sGetInputText);
	sXMLLTPlon = std::string((LPCTSTR) sGetInputText);

	cLTPAz.GetWindowText(sGetInputText);
	sXMLLTPaz = std::string((LPCTSTR) sGetInputText);

	cXFalseOrigin.GetWindowText(sGetInputText);
	sXMLLTP_XfalseOrigin = std::string((LPCTSTR) sGetInputText);

	cYFalseOrigin.GetWindowText(sGetInputText);
	sXMLLTP_YfalseOrigin = std::string((LPCTSTR) sGetInputText);

	cHeightOffset.GetWindowText(sGetInputText);
	sXMLLTP_heightOffset = std::string((LPCTSTR) sGetInputText);
}
